"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const agency_service_1 = __importDefault(require("../services/agency.service"));
const http_status_codes_1 = require("http-status-codes");
class AgencyController {
    constructor() {
        this.agencyService = new agency_service_1.default();
        this.getAgencies = async (req, res, next) => {
            try {
                const findAllAgenciesData = await this.agencyService.findAllAgencies();
                this.iResponse = { data: findAllAgenciesData, message: 'find all' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        this.getAgencyById = async (req, res, next) => {
            const agencyId = req.params.id;
            try {
                const findOneAgencyData = await this.agencyService.findAgencyById(agencyId);
                this.iResponse = { data: findOneAgencyData, message: 'findOne' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        this.createAgency = async (req, res, next) => {
            const agencyData = req.body;
            try {
                const createAgencyData = await this.agencyService.createAgency(agencyData);
                this.iResponse = { data: createAgencyData, message: 'created' };
                res.status(http_status_codes_1.StatusCodes.CREATED).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        this.updateAgency = async (req, res, next) => {
            const agencyId = req.params.id;
            const agencyData = req.body;
            try {
                const updateAgencyData = await this.agencyService.updateAgency(agencyId, agencyData);
                this.iResponse = { data: updateAgencyData, message: 'updated' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        this.deleteAgency = async (req, res, next) => {
            const agencyId = req.params.id;
            try {
                const deleteAgencyData = await this.agencyService.deleteAgencyData(agencyId);
                this.iResponse = { data: deleteAgencyData, message: 'deleted' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
    }
}
exports.default = AgencyController;
//# sourceMappingURL=agency.controller.js.map