"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const application_service_1 = __importDefault(require("../services/application.service"));
const http_status_codes_1 = require("http-status-codes");
class ApplicationController {
    constructor() {
        this.applicationService = new application_service_1.default();
        //Create Idea
        this.createIdea = async (req, res, next) => {
            const ideaData = req.body;
            console.log('inside controller', req.body);
            try {
                console.log('req.files', req.files);
                //Updating resources with s3 location
                if (req.files.proof) {
                    ideaData.proof = req.files.proof.map(file => {
                        return { media: file.originalname };
                    });
                }
                if (req.files.cv) {
                    ideaData.cv = req.files.cv.map(file => {
                        return { media: file.originalname };
                    });
                }
                if (req.files.award) {
                    ideaData.award = req.files.award.map(file => {
                        return { media: file.originalname };
                    });
                }
                if (req.files.benefit) {
                    ideaData.benefit = req.files.benefit.map(file => {
                        return { media: file.originalname };
                    });
                }
                ideaData.slug = ideaData.category.toString().split(' ').join('-');
                // res.status(StatusCodes.CREATED).json(this.iResponse);
                const createideaData = await this.applicationService.createIdea(ideaData);
                this.iResponse = { data: createideaData, message: 'created' };
                res.status(http_status_codes_1.StatusCodes.CREATED).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        //Update Idea
        this.updateIdea = async (req, res, next) => {
            // console.log(req);
            const ideaId = req.body.id;
            const ideaData = req.body;
            console.log('iid', ideaData);
            console.log(ideaId);
            console.log('req.files', req.files);
            //Updating resources with s3 location
            if (req.files.proof) {
                ideaData.proof = req.files.proof.map(file => {
                    return { media: file.originalname };
                });
            }
            if (req.files.cv) {
                ideaData.cv = req.files.cv.map(file => {
                    return { media: file.originalname };
                });
            }
            if (req.files.award) {
                ideaData.award = req.files.award.map(file => {
                    return { media: file.originalname };
                });
            }
            if (req.files.benefit) {
                ideaData.benefit = req.files.benefit.map(file => {
                    return { media: file.originalname };
                });
            }
            try {
                const updateIdeaData = await this.applicationService.updateIdea(ideaId, ideaData);
                this.iResponse = { data: updateIdeaData, message: 'updated' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        //Get Idea by ID
        this.getIdeaById = async (req, res, next) => {
            const ideaId = req.params.id;
            try {
                const findOneApplicationData = await this.applicationService.getIdeaById(ideaId);
                this.iResponse = { data: findOneApplicationData, message: 'findOne' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        //Get Challenge Specific Ideas
        this.getApplicationByChallengeId = async (req, res, next) => {
            const challengeId = req.params.id;
            try {
                const findOneApplicationData = await this.applicationService.getIdeaByChallengeId(challengeId);
                this.iResponse = { data: findOneApplicationData, message: 'find' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        //Get User Specific Idea
        this.getApplicationByUser = async (req, res, next) => {
            const userId = req.params.id;
            try {
                const findOneApplicationData = await this.applicationService.findApplicationByUser(userId);
                this.iResponse = { data: findOneApplicationData, message: 'findAllIdeaByUser' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        //Old
        this.getApplications = async (req, res, next) => {
            try {
                const findAllApplicationsData = await this.applicationService.findAllApplication();
                this.iResponse = { data: findAllApplicationsData, message: 'find all' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        this.getApplicationById = async (req, res, next) => {
            const applicationId = req.params.id;
            try {
                const findOneApplicationData = await this.applicationService.findApplicationById(applicationId);
                this.iResponse = { data: findOneApplicationData, message: 'findOne' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        this.updateApplication = async (req, res, next) => {
            const applicationId = req.params.id;
            const applicationData = req.body;
            try {
                const updateApplicationData = await this.applicationService.updateApplication(applicationId, { data: applicationData });
                this.iResponse = { data: updateApplicationData, message: 'updated' };
                console.log();
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        this.deleteApplication = async (req, res, next) => {
            const applicationId = req.params.id;
            try {
                const deleteApplicationData = await this.applicationService.deleteApplicationData(applicationId);
                this.iResponse = { data: deleteApplicationData, message: 'deleted' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        this.createApplication = async (req, res, next) => {
            const applicationData = req.body;
            try {
                const createApplicationData = await this.applicationService.createApplication(applicationData);
                this.iResponse = { data: createApplicationData, message: 'created' };
                res.status(http_status_codes_1.StatusCodes.CREATED).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
    }
}
exports.default = ApplicationController;
//# sourceMappingURL=application.controller.js.map