"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const auth_service_1 = __importDefault(require("../services/auth.service"));
class AuthController {
    constructor() {
        this.authService = new auth_service_1.default();
        this.signUp = async (req, res, next) => {
            const userData = req.body;
            try {
                const signUpUserData = await this.authService.signup(userData);
                res.status(201).json({ data: signUpUserData, message: 'signup' });
            }
            catch (error) {
                next(error);
            }
        };
        this.logIn = async (req, res, next) => {
            const userData = req.body;
            try {
                console.log("----------------------", userData);
                const authData = await this.authService.login(userData);
                if (authData.status == 200) {
                    res.setHeader('Set-Cookie', [authData.data.cookie]);
                    authData.data = authData.data.findUser;
                    res.status(200).json(authData);
                }
                else {
                    res.status(authData.status).json(authData);
                }
            }
            catch (error) {
                console.log(error);
            }
        };
        this.tokenValidator = async (req, res, next) => {
            try {
                console.log("----------------------", req.user);
                if (req.user) {
                    res.status(200).json(req.user);
                }
                // const authData = await this.authService.login();
                // if(authData.status == 200){
                //   res.setHeader('Set-Cookie', [authData.data.cookie]);
                //   authData.data = authData.data.findUser;
                //   res.status(200).json(authData);
                // }else{
                //   res.status(authData.status).json(authData);
                // }
            }
            catch (error) {
                console.log(error);
            }
        };
        this.logOut = async (req, res, next) => {
            const userData = req.user;
            try {
                const logOutUserData = await this.authService.logout(userData);
                res.setHeader('Set-Cookie', ['Authorization=; Max-age=0']);
                res.status(200).json({ data: logOutUserData, message: 'logout' });
            }
            catch (error) {
                next(error);
            }
        };
    }
}
exports.default = AuthController;
//# sourceMappingURL=auth.controller.js.map