"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const role_service_1 = __importDefault(require("../services/role.service"));
const http_status_codes_1 = require("http-status-codes");
class RoleController {
    constructor() {
        this.roleService = new role_service_1.default();
        this.getRoles = async (req, res, next) => {
            try {
                const findAllRolesData = await this.roleService.findAllRole();
                this.iResponse = { data: findAllRolesData, message: 'find all' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        this.getRoleById = async (req, res, next) => {
            const roleId = req.params.id;
            try {
                const findOneRoleData = await this.roleService.findRoleById(roleId);
                this.iResponse = { data: findOneRoleData, message: 'findOne' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        this.createRole = async (req, res, next) => {
            const roleData = req.body;
            try {
                const createRoleData = await this.roleService.createRole(roleData);
                this.iResponse = { data: createRoleData, message: 'created' };
                res.status(http_status_codes_1.StatusCodes.CREATED).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        this.updateRole = async (req, res, next) => {
            const roleId = req.params.id;
            const roleData = req.body;
            try {
                const updateRoleData = await this.roleService.updateRole(roleId, roleData);
                this.iResponse = { data: updateRoleData, message: 'updated' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        this.deleteRole = async (req, res, next) => {
            const roleId = req.params.id;
            try {
                const deleteRoleData = await this.roleService.deleteRoleData(roleId);
                this.iResponse = { data: deleteRoleData, message: 'deleted' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
    }
}
exports.default = RoleController;
//# sourceMappingURL=role.controller.js.map