"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const step_service_1 = __importDefault(require("../services/step.service"));
const http_status_codes_1 = require("http-status-codes");
class StepController {
    constructor() {
        this.stepService = new step_service_1.default();
        this.getSteps = async (req, res, next) => {
            try {
                const findAllStepsData = await this.stepService.findAllStep();
                this.iResponse = { data: findAllStepsData, message: 'find all' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        this.getStepById = async (req, res, next) => {
            const stepId = req.params.id;
            try {
                const findOneStepData = await this.stepService.findStepById(stepId);
                this.iResponse = { data: findOneStepData, message: 'findOne' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        this.createStep = async (req, res, next) => {
            const stepData = req.body;
            try {
                const createStepData = await this.stepService.createStep(stepData);
                this.iResponse = { data: createStepData, message: 'created' };
                res.status(http_status_codes_1.StatusCodes.CREATED).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        this.updateStep = async (req, res, next) => {
            const stepId = req.params.id;
            const stepData = req.body;
            try {
                const updateStepData = await this.stepService.updateStep(stepId, stepData);
                this.iResponse = { data: updateStepData, message: 'updated' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        this.deleteStep = async (req, res, next) => {
            const stepId = req.params.id;
            try {
                const deleteStepData = await this.stepService.deleteStepData(stepId);
                this.iResponse = { data: deleteStepData, message: 'deleted' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
    }
}
exports.default = StepController;
//# sourceMappingURL=step.controller.js.map