"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const user_service_1 = __importDefault(require("../services/user.service"));
const http_status_codes_1 = require("http-status-codes");
class UserController {
    constructor() {
        this.userService = new user_service_1.default();
        this.getUsers = async (req, res, next) => {
            try {
                const findAllUsersData = await this.userService.findAllUser();
                this.iResponse = { data: findAllUsersData, message: 'find all' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        this.getUserById = async (req, res, next) => {
            const userId = req.params.id;
            try {
                const findOneUserData = await this.userService.findUserById(userId);
                this.iResponse = { data: findOneUserData, message: 'findOne' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        this.createUser = async (req, res, next) => {
            const userData = req.body;
            try {
                const createUserData = await this.userService.createUser(userData);
                this.iResponse = { data: createUserData, message: 'created' };
                res.status(http_status_codes_1.StatusCodes.CREATED).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        this.updateUser = async (req, res, next) => {
            const userId = req.params.id;
            const userData = req.body;
            try {
                const updateUserData = await this.userService.updateUser(userId, userData);
                this.iResponse = { data: updateUserData, message: 'updated' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        this.deleteUser = async (req, res, next) => {
            const userId = req.params.id;
            try {
                const deleteUserData = await this.userService.deleteUserData(userId);
                this.iResponse = { data: deleteUserData, message: 'deleted' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
    }
}
exports.default = UserController;
//# sourceMappingURL=user.controller.js.map