"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const video_service_1 = __importDefault(require("../services/video.service"));
const http_status_codes_1 = require("http-status-codes");
class VideoController {
    constructor() {
        this.videoService = new video_service_1.default();
        this.getVideos = async (req, res, next) => {
            try {
                const findAllVideosData = await this.videoService.findAllVideo();
                this.iResponse = { data: findAllVideosData, message: 'find all' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        this.getVideoById = async (req, res, next) => {
            const videoId = req.params.id;
            try {
                const findOneVideoData = await this.videoService.findVideoById(videoId);
                this.iResponse = { data: findOneVideoData, message: 'findOne' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        this.createVideo = async (req, res, next) => {
            const videoData = req.body;
            try {
                const createVideoData = await this.videoService.createVideo(videoData);
                this.iResponse = { data: createVideoData, message: 'created' };
                res.status(http_status_codes_1.StatusCodes.CREATED).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        this.updateVideo = async (req, res, next) => {
            const videoId = req.params.id;
            const videoData = req.body;
            try {
                const updateVideoData = await this.videoService.updateVideo(videoId, videoData);
                this.iResponse = { data: updateVideoData, message: 'updated' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
        this.deleteVideo = async (req, res, next) => {
            const videoId = req.params.id;
            try {
                const deleteVideoData = await this.videoService.deleteVideoData(videoId);
                this.iResponse = { data: deleteVideoData, message: 'deleted' };
                res.status(http_status_codes_1.StatusCodes.OK).json(this.iResponse);
            }
            catch (error) {
                next(error);
            }
        };
    }
}
exports.default = VideoController;
//# sourceMappingURL=video.controller.js.map