"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsonwebtoken_1 = __importDefault(require("jsonwebtoken"));
const HttpException_1 = __importDefault(require("../exceptions/HttpException"));
const user_model_1 = __importDefault(require("../models/user.model"));
const authMiddleware = async (req, res, next) => {
    try {
        const token = req.body.token || req.query.token || req.headers["authorization"];
        if (token) {
            const secret = process.env.JWT_SECRET;
            const verificationResponse = (await jsonwebtoken_1.default.verify(token.authorization, secret));
            console.log(verificationResponse);
            const userId = verificationResponse._id;
            const findUser = await user_model_1.default.findById(userId);
            if (findUser) {
                req.user = findUser;
                next();
            }
            else {
                next(new HttpException_1.default(401, 'Invalid Authentication Token'));
            }
        }
        else {
            next(new HttpException_1.default(401, 'Authentication Token Missing'));
        }
    }
    catch (error) {
        next(new HttpException_1.default(401, 'Invalid Authentication Token'));
    }
};
exports.default = authMiddleware;
//# sourceMappingURL=auth.middleware.js.map