"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const mongoose_1 = require("mongoose");
const paginate_plugin_1 = __importDefault(require("./plugins/paginate.plugin"));
const toJSON_plugin_1 = __importDefault(require("./plugins/toJSON.plugin"));
const agencySchema = new mongoose_1.Schema({
    agencyName: {
        type: String,
        required: true,
        unique: true,
        lowercase: true,
    },
    agencyCode: {
        type: String,
        required: true,
        unique: true,
        lowercase: true,
    },
    email: {
        type: String,
        required: true,
        unique: true,
        lowercase: true,
    },
    userId: {
        type: mongoose_1.SchemaTypes.ObjectId,
        ref: 'User',
        required: true,
    },
    status: {
        type: String,
        enum: ['ACTIVE', 'INACTIVE'],
        required: true,
    },
}, {
    timestamps: true,
});
agencySchema.plugin(toJSON_plugin_1.default);
agencySchema.plugin(paginate_plugin_1.default);
const agencyModel = (0, mongoose_1.model)('Agency', agencySchema);
exports.default = agencyModel;
//# sourceMappingURL=agency.model.js.map