"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const mongoose_1 = require("mongoose");
const paginate_plugin_1 = __importDefault(require("./plugins/paginate.plugin"));
const toJSON_plugin_1 = __importDefault(require("./plugins/toJSON.plugin"));
const applicationSchema = new mongoose_1.Schema({
    data: {
        type: Object,
        required: true,
    },
    // resources: [],
    challenge: {
        type: mongoose_1.SchemaTypes.ObjectId,
        ref: 'Challenge',
        required: true,
    },
    user: {
        type: mongoose_1.SchemaTypes.ObjectId,
        ref: 'User',
        required: true,
    },
    // financial_doc: {
    //   type: String,
    // },
    // project_doc: {
    //   type: String,
    // },
    // status: {
    //   type: String,
    //   enum: ['PENDING', 'DUPLICATE', 'CONFIRMED', 'UNDER PRESCREENING', 'UNDER SCREENING', 'SHORTLISTED', 'WINNER'],
    //   default: 'PENDING',
    //   required: true,
    // },
}, {
    timestamps: true,
});
applicationSchema.plugin(toJSON_plugin_1.default);
applicationSchema.plugin(paginate_plugin_1.default);
const applicationModel = (0, mongoose_1.model)('Application', applicationSchema);
exports.default = applicationModel;
//# sourceMappingURL=application.model.js.map