"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const mongoose_1 = require("mongoose");
const paginate_plugin_1 = __importDefault(require("./plugins/paginate.plugin"));
const toJSON_plugin_1 = __importDefault(require("./plugins/toJSON.plugin"));
const challengeSchema = new mongoose_1.Schema({
    agency_id: {
        type: mongoose_1.SchemaTypes.ObjectId,
        ref: 'Agency',
        required: true,
    },
    challenge_id: {
        type: String,
    },
    category: {
        type: String,
        required: true,
    },
    year: {
        type: String,
        required: true,
    },
    sdg: {
        type: mongoose_1.SchemaTypes.ObjectId,
        ref: 'sdg',
        required: true,
    },
    slug: {
        type: String,
        required: false,
    },
    description: {
        type: String,
        required: true,
    },
    key_areas: {
        type: String,
    },
    who_can_apply: {
        type: String,
    },
    incentive: {
        type: String,
    },
    parameter_for_selection: {
        type: String,
    },
    guideline: {
        type: String,
    },
    header_line: {
        type: String,
    },
    web_link: {
        type: String,
    },
    c_image: {
        type: String,
    },
    logos: [],
    resources: [],
    twitter_link: {
        type: String,
    },
    linkedin_link: {
        type: String,
    },
    facebook_link: {
        type: String,
    },
    steps: [],
    status: {
        type: String,
        default: 'ACTIVE',
        enum: ['ACTIVE', 'INACTIVE'],
        required: true,
    },
}, {
    timestamps: true,
});
challengeSchema.plugin(toJSON_plugin_1.default);
challengeSchema.plugin(paginate_plugin_1.default);
const challengeModel = (0, mongoose_1.model)('Challenge', challengeSchema);
exports.default = challengeModel;
//# sourceMappingURL=challenge.model.js.map