"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const mongoose_1 = require("mongoose");
const paginate_plugin_1 = __importDefault(require("./plugins/paginate.plugin"));
const toJSON_plugin_1 = __importDefault(require("./plugins/toJSON.plugin"));
const roleSchema = new mongoose_1.Schema({
    name: {
        type: String,
        required: true,
        unique: true,
        lowercase: true,
    },
    permissions: {
        type: Object,
    },
    status: {
        type: String,
        enum: ['ACTIVE', 'INACTIVE'],
        required: true,
    },
}, {
    timestamps: true,
});
roleSchema.plugin(toJSON_plugin_1.default);
roleSchema.plugin(paginate_plugin_1.default);
const roleModel = (0, mongoose_1.model)('Role', roleSchema);
exports.default = roleModel;
//# sourceMappingURL=role.model.js.map