"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const mongoose_1 = require("mongoose");
const paginate_plugin_1 = __importDefault(require("./plugins/paginate.plugin"));
const toJSON_plugin_1 = __importDefault(require("./plugins/toJSON.plugin"));
const stepSchema = new mongoose_1.Schema({
    isActive: {
        type: Boolean
    },
    stage_name: {
        type: String
    },
    tag_line: {
        type: String
    },
    end_date: {
        type: Date
    },
    mandFlg: {
        type: Boolean
    },
    parameters: [],
    status: {
        type: String,
        enum: ['ACTIVE', 'INACTIVE'],
        default: "ACTIVE"
    },
}, {
    timestamps: true,
});
stepSchema.plugin(toJSON_plugin_1.default);
stepSchema.plugin(paginate_plugin_1.default);
const stepModel = (0, mongoose_1.model)('Step', stepSchema);
exports.default = stepModel;
//# sourceMappingURL=step.model.js.map