"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const mongoose_1 = require("mongoose");
const paginate_plugin_1 = __importDefault(require("./plugins/paginate.plugin"));
const toJSON_plugin_1 = __importDefault(require("./plugins/toJSON.plugin"));
const videoSchema = new mongoose_1.Schema({
    title: {
        type: String,
        required: true,
    },
    link: {
        type: String,
        required: true,
    },
    sort_order: {
        type: Number,
    },
    status: {
        type: String,
        enum: ['ACTIVE', 'INACTIVE'],
        default: 'ACTIVE',
        required: true,
    },
}, {
    timestamps: true,
});
videoSchema.plugin(toJSON_plugin_1.default);
videoSchema.plugin(paginate_plugin_1.default);
const videoModel = (0, mongoose_1.model)('Video', videoSchema);
exports.default = videoModel;
//# sourceMappingURL=video.model.js.map