"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
require("dotenv/config");
const app_1 = __importDefault(require("./app"));
const auth_route_1 = __importDefault(require("./routes/auth.route"));
const index_route_1 = __importDefault(require("./routes/index.route"));
const user_route_1 = __importDefault(require("./routes/user.route"));
const role_route_1 = __importDefault(require("./routes/role.route"));
const challenge_route_1 = __importDefault(require("./routes/challenge.route"));
const step_route_1 = __importDefault(require("./routes/step.route"));
const application_route_1 = __importDefault(require("./routes/application.route"));
const video_route_1 = __importDefault(require("./routes/video.route"));
const validateEnv_1 = __importDefault(require("./utils/validateEnv"));
const agency_route_1 = __importDefault(require("./routes/agency.route"));
const init_route_1 = __importDefault(require("./routes/init.route"));
(0, validateEnv_1.default)();
const app = new app_1.default([
    new index_route_1.default(),
    new user_route_1.default(),
    new auth_route_1.default(),
    new role_route_1.default(),
    new init_route_1.default(),
    new challenge_route_1.default(),
    new step_route_1.default(),
    new application_route_1.default(),
    new video_route_1.default(),
    new agency_route_1.default(),
]);
process.on('unhandledRejection', (reason, p) => {
    console.error(reason, 'Unhandled Rejection at Promise', p);
})
    .on('uncaughtException', err => {
    console.error(err, 'Uncaught Exception thrown');
    process.exit(1);
});
app.listen();
//# sourceMappingURL=server.js.map