"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const HttpException_1 = __importDefault(require("../exceptions/HttpException"));
const challenge_model_1 = __importDefault(require("../models/challenge.model"));
const util_1 = require("../utils/util");
class ChallengeService {
    constructor() {
        this.challenges = challenge_model_1.default;
    }
    async findAllChallenge() {
        const challenges = await this.challenges.find().populate(["agency_id", 'sdg']);
        return challenges;
    }
    async findChallengeById(challengeId) {
        const findChallenge = await this.challenges.findById(challengeId).populate(["agency_id", 'sdg']);
        if (!findChallenge)
            throw new HttpException_1.default(409, 'Challenge Not Found');
        return findChallenge;
    }
    async getChallengeStageById(challengeId) {
        const challengeData = await this.challenges.findById(challengeId);
        var currentdate = Date.now();
        var currentstage = '';
        var lefttime;
        var isstarted = false;
        var position;
        let steps = challengeData.steps;
        if ((new Date(currentdate).getTime() < new Date(steps[0].end_date).getTime())) {
            challengeData.currentstage = 'Challenge Opens In';
            lefttime = new Date(steps[0].end_date).getTime() - new Date(currentdate).getTime();
            challengeData.lefttime = (lefttime / 1000);
        }
        else {
            isstarted = true;
            for (let i = 0; i < steps.length; i++) {
                console.log('i', i);
                if ((new Date(currentdate).getTime() > new Date(steps[i].end_date).getTime()) && (new Date(currentdate).getTime() < new Date(steps[i + 1].end_date).getTime())) {
                    if (steps[i + 1].stage_name === 'Idea Submission Closed') {
                        currentstage = steps[i].stage_name;
                        console.log('inside if');
                        console.log('stage name ic');
                        position = i;
                    }
                    else {
                        currentstage = steps[i + 1].stage_name;
                        console.log('stage name else', currentstage);
                        position = i + 1;
                    }
                    lefttime = new Date(steps[i + 1].end_date).getTime() - new Date(currentdate).getTime();
                    challengeData.currentstage = currentstage;
                    challengeData.lefttime = (lefttime / 1000);
                    console.log('lettime', lefttime);
                    // element.set('currentstage',currentstage)
                    console.log('match found', currentstage);
                }
            }
        }
        // console.log('hey hey',element.steps)
        var challenge_stage = {
            currentstage: currentstage,
            lefttime: lefttime,
            position: position,
            steps: steps
        };
        console.log(challenge_stage, 'j91082');
        if (!challengeData)
            throw new HttpException_1.default(409, 'Challenge Not Found');
        return challenge_stage;
    }
    async findChallengeByAgency(agencyId) {
        const findChallenge = await this.challenges.find({ agency_id: agencyId }).populate(["agency_id", 'sdg']);
        if (!findChallenge)
            throw new HttpException_1.default(409, 'Challenge Not Found');
        return findChallenge;
    }
    async createChallenge(challengeData) {
        if ((0, util_1.isEmpty)(challengeData))
            throw new HttpException_1.default(400, 'Challenge Data Not Found');
        //  const findChallenge: Challenge = await this.challenges.findOne({ category: challengeData.category,year:challengeData.year });
        //  if (findChallenge) throw new HttpException(409, `Category:${challengeData.category}, Year:${challengeData.year} already exists`);
        const createChallengeData = await this.challenges.create(challengeData);
        return createChallengeData;
    }
    async updateChallenge(challengeId, challengeData) {
        if ((0, util_1.isEmpty)(challengeData))
            throw new HttpException_1.default(400, 'Challenge Data Not Found');
        const updateChallengeById = await this.challenges.findByIdAndUpdate(challengeId, { $set: challengeData });
        if (!updateChallengeById)
            throw new HttpException_1.default(409, 'Challenge Data Not Found');
        return updateChallengeById;
    }
    async deleteChallengeData(challengeId) {
        const deleteChallengeById = await this.challenges.findByIdAndDelete(challengeId);
        if (!deleteChallengeById)
            throw new HttpException_1.default(409, 'Challenge Data Not Found');
        return deleteChallengeById;
    }
}
exports.default = ChallengeService;
//# sourceMappingURL=challenge.service.js.map