"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const agency_model_1 = __importDefault(require("../models/agency.model"));
const sdg_model_1 = __importDefault(require("../models/sdg.model"));
const stream_1 = require("stream");
const data_1 = require("../utils/data");
class initialiseDataService {
    constructor() {
        this.agencies = agency_model_1.default;
        this.sdgModel = sdg_model_1.default;
    }
    async initialiseData() {
        //Check if existing
        let existingSdg = await sdg_model_1.default.find({});
        if (existingSdg.length == 0) {
            // Create readable stream from the array list of cards
            const readableStream = stream_1.Readable.from(data_1.sdg);
            // Turn on the stream and repeat the process to create cards
            readableStream.on('data', async (data) => {
                await sdg_model_1.default.create(data);
            });
            console.log("Init Data");
        }
        else {
            console.log('SDG Already Exists');
        }
    }
}
exports.default = initialiseDataService;
//# sourceMappingURL=initialise_data.js.map