"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createUniqueId = exports.uniqueIdIncrement = exports.generate_unique_id = void 0;
const uniqueid_model_1 = __importDefault(require("../models/uniqueid.model"));
const createUniqueId = async (type, agency_code) => {
    try {
        let code = agency_code.toLowerCase();
        let create = await uniqueid_model_1.default.create({
            type: type,
            agency_code: code,
            description: `Unique ID for ${type}`,
        });
        if (create) {
            return 'UID created';
        }
    }
    catch (error) {
        return 'UID Creation failed';
    }
};
exports.createUniqueId = createUniqueId;
const generate_unique_id = async (type, agency) => {
    let firstChar = type.toString().charAt(0);
    let data = await uniqueid_model_1.default.findOne({ type: type, agency_code: agency });
    if (data) {
        let id = '' + (Number(data.currentValue) + 1);
        var pad = '000';
        id = pad.substring(0, pad.length - id.length) + id;
        let uniqueid = `${firstChar}${new Date().getFullYear()}-${data.agency_code}-${id}`;
        return uniqueid;
    }
};
exports.generate_unique_id = generate_unique_id;
const uniqueIdIncrement = async (type, agency) => {
    let update = await uniqueid_model_1.default.updateOne({ type: type, agency_code: agency }, { $inc: { currentValue: 1 } });
    console.log(update);
};
exports.uniqueIdIncrement = uniqueIdIncrement;
//# sourceMappingURL=unique_id_generator.js.map